Added support for 3rd argument = mount dir
[backups/.git] / scripts / restore-script.sh
index 5ae9fe792ea69a2732958bdb842d94ba241e5cee..66ac4fb5b4da27c64842c96444daf04313059a71 100755 (executable)
@@ -1,28 +1,67 @@
 #!/bin/sh
 
-echo "Ran restore script with $@"
+function err() {
+  echo 2>&1 "-E- $1"
+  exit 1
+}
+
+if [ ! -z "$3" ]; then
+  mountdir=$3 
+fi
+
+if [ -z "$mountdir" ]; then
+  echo >&2 '$mountdir must be set'
+  exit 1
+fi
 
-exit 0
+if [ -z "$rundir" ]; then
+  echo >&2 '$rundir must be set'
+  exit 1
+fi
 
-export PATH=$rundir:/bin:/usr/bin
+export PATH=${rundir%%/}:/bin:/usr/bin:/sbin:/usr/sbin:/sw/bin
 
-if [ $# != 1 ]; then
-  echo >&2 "Usage: $0 <source-directory> <target-directory>"
-  echo >&2 "Example: $0 / /"
+if [ ! -d "$1" -o ! -d "$2" ]; then
+  echo >&2 "Usage: $0 <source-dir> <target-dir> [<mnt-dir>]"
+  echo >&2 "       source-dir - directory on backup disks to restore from"
+  echo >&2 "       target-dir - directory to restore files to"
+  echo >&2 "       mnt-dir    - directory where backup disk is mounted (optional)"
+  echo >&2 "Example: $0 / / /mnt/cdrom"
   exit 1
 fi
 
-# Get the device with the CD in it here
-device=$(mount | grep "on $mountdir " | awk '{print$1}')
+device=$(mount | grep "on ${mountdir%%/} " | awk '{print$1}')
+
+if [ -z "$device" ]; then
+  echo >&2 "Cannot determine cdrom device"
+  exit 1
+fi
+
+cp ${mountdir%%/}/backups.db ${mountdir%%/}/backup-status.txt $rundir
+dbfile=${rundir%%/}/backups.db
+
+dates=$(cat $dbfile | list-dates.sh)
+
+for date in $dates; do
+  success=false
+  while ! $success; do
+    eject $device
+    [ $? != 0 ] && err "Cannot eject the disk. Drive is busy. Run lsof $mountdir to see why."
+    echo >&2 "Please insert backup disk:  $date"
+    echo >&2 "Press Enter to continue"
+    read bogus
+    eject -t $device
+
+    # Mount the media
+    mount -t ext2 $device ${mountdir%%/}
 
-cp $mountdir/backups.db $mountdir
+    if grep -q $date ${mountdir%%/}/backup-status.txt; then
+      success=true
+    else
+      echo "This doesn't seem to be the right disk."
+    fi
+  done
 
-for date in $(cat $dbfile | list-dates.sh); do
-  eject $device
-  echo >&2 "Please insert backup disk:  $date"
-  echo >&2 "Then press any key"
-  read bogus
-  # Mount the media
-  # rsync-cmd.sh won't work here in its current encarnation
-  cat $dbfile | files-from-date.sh | rsync-cmd.sh $1
+  rsyncopts="-W -H -S -l -p -t -g -o -0 --files-from=- --stats --progress"
+  cat $dbfile | files-from-date.sh $date | grep -z -e "${1}" | rsync $rsyncopts ${mountdir%%/}/ ${2%%/}/
 done